<?php 
/**
 * Ecuación de segundo grado - segundo_grado.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2011 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2011-11-25
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Ecuación de segundo grado (Resultado). 
  Exámenes. PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>

<body>
<h1>Ecuación de segundo grado (Resultado)</h1>
<?php
function recoge($var)
{ 
    $tmp = (isset($_REQUEST[$var])) ? strip_tags(trim(htmlspecialchars($_REQUEST[$var]))) : '';
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    return $tmp;
}

$a   = recoge('a');
$b   = recoge('b');
$c   = recoge('c');
$aOk = FALSE;
$bOk = FALSE;
$cOk = FALSE;

if ($a == "") {
    print "<p class=\"aviso\">No ha escrito el coeficiente a.</p>\n";
} elseif (!is_numeric($a)) { 
    print "<p class=\"aviso\">No ha escrito el coeficiente a como número.</p>\n";
} else {
    $aOk = TRUE;
}

if ($b == "") {
    print "<p class=\"aviso\">No ha escrito el coeficiente b.</p>\n";
} elseif (!is_numeric($b)) { 
    print "<p class=\"aviso\">No ha escrito el coeficiente b como número.</p>\n";
} else {
    $bOk = TRUE;
}

if ($c == "") {
    print "<p class=\"aviso\">No ha escrito el coeficiente c.</p>\n";
} elseif (!is_numeric($c)) { 
    print "<p class=\"aviso\">No ha escrito el coeficiente c como número.</p>\n";
} else {
    $cOk = TRUE;
}
if ($aOk && $bOk && $cOk) {
    print "<p>La ecuación <span style=\"font-size: 200%\">";
    if ($a==1) {
        print "x<sup>2</sup>";
    } elseif ($a==-1) {
        print "-x<sup>2</sup>";
    } elseif ($a!=0) {
        print "{$a}x<sup>2</sup>";
    }
    if ($b==1) {
        if ($a!=0) {
            print "+";
        }
        print "x";
    } elseif ($b>0) {
        if ($a!=0) {
            print "+";
        }
        print $b."x";
    } elseif ($b==-1) {
        print "-x";
    } elseif ($b<0) {
        print $b."x";
    }
    if ($c>0) {
        if (($a!=0)||($b!=0)) {
            print "+";
        }
        print (int)$c;
    } elseif ($c<0) {
        print $c;
    }
    print " = 0</span> "; 
    
    if ($a==0) {
        if ($b==0) {
            if ($c==0) {
                print "tiene infinitas soluciones. Todos los números son solución</p>\n";
            } else {
                print "no tiene solución.</p>\n";
            }
        } else {
            print "tiene una única solución: <span style=\"font-size: 200%\">x = "
                 .(-$c/$b)."</span></p>\n";
        }
    } else {
        $d = $b*$b-4*$a*$c;
        if ($d>0) {
            $d2 = sqrt($d);
            print "tiene dos soluciones: <span style=\"font-size: 200%\">x"
                 ."<sub>1</sub> = ".((-$b+$d2)/(2*$a))." ; x<sub>2</sub> = "
                 .((-$b-$d2)/(2*$a))."</span></p>\n";
        } else if ($d==0) {
            print "tiene una única solución: <span style=\"font-size: 200%\">x = "
                 .(-$b/(2*$a))."</span></p>\n";
        } else {
            print "no tiene soluciones reales.</p>\n";
        }
    }
}
print "<p><a href=\"segundo_grado.html\">Volver al formulario.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 25 de noviembre de 2011
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>
